package org.rcisoft.business.barrange.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.barrange.entity.BSubAgency;
import org.rcisoft.business.barrange.entity.BSubtask;
import org.rcisoft.business.barrange.entity.ScheduleDto;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.barrange.entity.BArrange;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.ArrayList;
import java.util.List;

/**
* Created with  on 2018-4-19 10:28:59.
*/
@Repository
public interface BArrangeRepository extends BaseMapper<BArrange> {


    //企业人员查看自身公司的排课信息-------------------------------------------------------------------------------------
    @Select("<script>select b_arrange.business_id,term_code,description,agency_code,b_arrange.status from b_arrange "
            + "LEFT JOIN b_subtask ON b_arrange.business_id = b_subtask.arrange_id "
            + "LEFT JOIN b_sub_agency ON b_subtask.business_id = b_sub_agency.subtask_id "
            + "where 1=1 and agency_code = #{agencyCode} "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "<if test=\"status !=null and status != '' \">and b_sub_agency.status = #{status} </if> "
            + "GROUP BY b_arrange.business_id "
            + "</script>")
    @ResultMap(value = "BaseResultMapByAgencyCode")
    List<BArrange> queryByAgencyCode(BArrange bArrange);

    List<BSubtask> queryByAgencyCode2(String agencyCode);

    List<BSubtask> queryByAgencyCode3(String agencyCode);

    //-----------------------------------------------------------------------------------------------------------------

    //维护人员查看全部的排课信息----------------------------------------------------------------------------------------
    @Select("<script>select * from b_arrange where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "<if test=\"termCode !=null and termCode != '' \">and term_code = #{termCode} </if> "
            + "<if test=\"status !=null and status != '' \">and status = #{status} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap2")
    List<BArrange> queryAll(BArrange bArrange);


    @Select("<script>select name,business_id from b_subtask where 1=1 "
            + "and del_flag = 0 "
            + "and flag = 1 "
            + "and arrange_id = #{businessId} GROUP BY name"
            + "</script>")
    @ResultMap(value = "bSubtaskResultMap")
    List<BSubtask> queryBSubtask(String businessId);

    @Select("<script>select * from b_sub_agency where 1=1 "
            + "and del_flag = 0 "
            + "and flag = 1 and subtask_id = #{businessId}"
            + "</script>")
    @ResultMap(value = "BSubAgencyResultMap")
    List<BSubtask> queryBSubtask1(String businessId);

    //-----------------------------------------------------------------------------------------------------------------


    @Select("<script>select * from b_schedule_dto LEFT JOIN b_subtask on b_schedule_dto.subtask_id = b_subtask.business_id " +
            "LEFT JOIN b_arrange on b_subtask.arrange_id = b_arrange.business_id where 1=1 " +
            "and b_subtask.business_id = #{bSubtaskId}" +
            "</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryDtoByAgencySubtaskId(String bSubtaskId);

    @Select("<script>select * from b_schedule_dto where sub_agency_id = #{subAgencyId} GROUP BY lesson_code</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryDtoBySubAgencyId(String subAgencyId);

    @Select("<script>select * from b_schedule_dto LEFT JOIN b_subtask on b_schedule_dto.subtask_id = b_subtask.business_id " +
            "LEFT JOIN b_arrange on b_subtask.arrange_id = b_arrange.business_id where 1=1 " +
            "and b_arrange.term_code = #{2} and b_subtask.name = #{1} and b_subtask.agency_code = #{0} " +
            "<if test=\"teacherCode !=null and teacherCode != '' \">and teacher_code = #{teacherCode} </if> " +
            "</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryDtoByAgencyMany(String agencyCode,String name,String termCode,@Param("teacherCode") String teacherCode);

    @Select("select business_id from b_sub_agency where subtask_id = #{subTaskId} and del_flag = 0 and flag = 1")
    List<String> querySubAgencyId(String subTaskId);

    @Select("select DISTINCT(status) from b_sub_agency where subtask_id = #{subTaskId} and del_flag = 0 and flag = 1")
    List<String> querySubTaskStatus(String subTaskId);

    int insertList(ArrayList<ScheduleDto> list);

    int insertBSubtask(List<BSubtask> list);

    int insertBSubAgency(List<BSubAgency> list);


}

