package org.rcisoft.business.bcompany.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bcompany.entity.BCompany;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by Administrator on 2018/5/2.
 */
@Repository
public interface BCompanyRepository extends BaseMapper<BCompany>{


    @Select("<script>SELECT bc.*,ba.name as agencyName,su.`name` as name," +
            "sr.role_name as roleName,sr.`code` as roleCode " +
            "FROM b_company bc \n" +
            "LEFT JOIN s_user su on su.login_name = bc.`code`\n" +
            "LEFT JOIN b_agency ba on ba.`code` = bc.agency_code \n" +
            "LEFT JOIN s_r_user_role ur ON su.business_id = ur.user_id\n" +
            "LEFT JOIN s_role sr on ur.role_id = sr.business_id\n" +
            "where bc.del_flag != 1 and su.del_flag != 1 "+
            "<if test=\"name!=null and name != ''\">and su.`name` like CONCAT('%',#{name},'%') </if>"+
            "<if test=\"code!=null and code != ''\">and bc.`code` like CONCAT('%',#{code},'%') </if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BCompany> queryCompanys(BCompany param);
}
