package org.rcisoft.business.bopinion.service.impl;

import org.rcisoft.business.barrange.entity.BSubtask;
import org.rcisoft.business.bopinion.dao.BOpinionRepository;
import org.rcisoft.business.bopinion.entity.BOpinion;
import org.rcisoft.business.bopinion.service.BOpinionService;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.util.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * Created by Administrator on 2017/12/21.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
public class BOpinionServiceImpl implements BOpinionService{

    @Autowired
    private BOpinionRepository bOpinionRepository;

    @Override
    public List<BOpinion> queryOpinionBySlId(String slId) {
        return bOpinionRepository.queryOpinionBySlId(slId);
    }

    /**
     * 审核通过
     * @param businessId
     * @return
     */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel auditPass(String businessId) {
        int line = bOpinionRepository.changeSubtaskStatus(businessId);
        return new PersistModel(line);
    }

    /**
     * 审核驳回
     * @param opinion
     * @param id
     * @return
     */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(String opinion,String id) {
        BSubtask bSubtask = bOpinionRepository.querySubtaskInfo(id);
        BOpinion bOpinion = new BOpinion();
        bOpinion.setCommonBusinessId();
        bOpinion.setOpinion(opinion);
        bOpinion.setArrangeId(bSubtask.getArrangeId());
        bOpinion.setSubtaskId(bSubtask.getBusinessId());
        Date day=new Date();
        bOpinion.setCreateDate(day);
        int line = bOpinionRepository.insertSelective(bOpinion);
        return new PersistModel(line);
    }

}
