package org.rcisoft.business.brooms.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with  on 2018-4-23 9:26:21.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_rooms")
public class BRooms  extends IdEntity<BRooms> {

     /*教室类型*/
     @Length(min= 1 , max = 1, message = "长度为1")
     @NotBlank
     private String category;

     /*校区*/
     @Length(min= 1 , max = 1, message = "长度为1")
     @NotBlank
     private String campus;

     /*教学楼*/
     @Length(min= 1 , max = 64, message = "长度最短为1，最长为50")
     @NotBlank
     private String building;

     /*教室号*/
     @Length(min= 1 , max = 64, message = "长度最短为1，最长为50")
     @NotBlank
     private String classroomNo;

     /*教室名*/
     @Length(min= 1 , max = 64, message = "长度最短为1，最长为50")
     private String classroomName;

     /*座位数*/
     private Integer classSeat;

     /*考试座位数*/
     private Integer examSeat;

     /*计划*/
     @Length(min= 1 , max = 64, message = "长度最短为1，最长为50")
     private String plan;

     /*教室编号*/
     @Length(min= 1 , max = 64, message = "长度最短为1，最长为50")
     @NotBlank
     private String code;

     @Transient
     private String transitCampus;

     @Transient
     private String transitCategory;

    public BRooms(String code) {
         this.code = code;
    }

    public String getTransitCampus(){
          if(this.transitCampus != null && !this.transitCampus.equals("")){
               switch (this.transitCampus) {
                    case "0":
                         this.transitCampus = "校本部";
                         break;
                    case "1":
                         this.transitCampus = "新校区";
                         break;
               }
          }

          return this.transitCampus;
     }

     public String getTransitCategory(){
          if(this.transitCategory != null && !this.transitCategory.equals("")){
               switch (this.transitCategory) {
                    case "0":
                         this.transitCategory = "普通教室";
                         break;
                    case "1":
                         this.transitCategory = "听力教室";
                         break;
                    case "2":
                         this.transitCategory = "多媒体教室";
                         break;
                    case "3":
                         this.transitCategory = "实训机房";
                         break;
                    case "4":
                         this.transitCategory = "报告厅";
                         break;
                    case "5":
                         this.transitCategory = "多功能报告厅";
                         break;
                    case "6":
                         this.transitCategory = "阶梯教室";
                         break;
               }
          }

          return this.transitCategory;
     }
//     public String getCampus(){
//          if(this.campus != null && !this.campus.equals("")){
//               switch (this.campus) {
//                    case "0":
//                         this.transitCampus = "校本部";
//                         break;
//                    case "1":
//                         this.transitCampus = "新校区";
//                         break;
//               }
//          }
//          return this.campus;
//     }
//
//     public String getCategroy(){
//          if(this.category != null && !this.category.equals("")){
//               switch (this.category) {
//                    case "0":
//                         this.transitCategory = "普通教室";
//                         break;
//                    case "1":
//                         this.transitCategory = "听力教室";
//                         break;
//                    case "2":
//                         this.transitCategory = "多媒体教室";
//                         break;
//                    case "3":
//                         this.transitCategory = "实训机房";
//                         break;
//                    case "4":
//                         this.transitCategory = "报告厅";
//                         break;
//                    case "5":
//                         this.transitCategory = "多功能报告厅";
//                         break;
//                    case "6":
//                         this.transitCategory = "阶梯教室";
//                         break;
//               }
//          }
//          return this.category;
//     }

}

