package org.rcisoft.business.bslschedule.dao;

import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bslschedule.entity.BSlSchedule;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2018-5-2 16:39:34.
*/
@Repository
public interface BSlScheduleRepository extends BaseMapper<BSlSchedule> {

    /**
    * 分页查询 bSlSchedule
    *
    */
    @Select("<script>select * from b_sl_schedule where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BSlSchedule> queryBSlSchedules(BSlSchedule bSlSchedule);

    @Select("<script>select * from b_sl_schedule "
            + "left join b_edu_class on b_edu_class.code = b_sl_schedule.edu_class_code \n"
            + "left join b_lesson on b_lesson.code = b_sl_schedule.lesson_code \n"
            + "left join b_rooms on b_rooms.code = b_sl_schedule.room_code \n"
            + "left join s_user on s_user.login_name = b_sl_schedule.tea_code \n"
            + "where start_day between #{0} and #{1} and sub_agency_id = #{2} order by edu_class_code,start_day,seq"
            + "</script>"
    )
    @ResultMap(value = "BaseResultMap2" )
    List<BSlSchedule> queryMoreBSlSchedules(String minTime,String maxTime,String subAgencyId);

    int insertList(List<BSlSchedule> bSlSchedules);
}

